commit a1ec98dd963767551514cae86c7af56c6aa3f36e
Author: Ulrich Landgraf <landgraf@physik.uni-freiburg.de>
Date:   Mon Aug 15 16:50:36 2022 +0100

    Fix symlink-following.  Bug 2909
    
    Broken-by: ef57b25bfa

diff --git a/src/src/tls.c b/src/src/tls.c
index 76e72b5f5..32b29ee3e 100644
--- a/src/src/tls.c
+++ b/src/src/tls.c
@@ -156,7 +156,7 @@ for (unsigned loop = 20;
   if (--loop == 0) { errno = ELOOP; return FALSE; }
   filename = buf[0] == '/'
     ? string_copyn(buf, (unsigned)len)	/* mem released by tls_set_watch */
-    : string_sprintf("%.*s/%.*s", (int)(s - filename), (int)len);
+    : string_sprintf("%.*s/%.*s", (int)(s - filename), filename, (int)len, buf);
   s = Ustrrchr(filename, '/');
   }
 if (errno != EINVAL)

